<!DOCTYPE html> 
<html>
	<head>
		<meta charset="utf-8"/>
		<title>JsEOQ Basic Web Socket Example</title>
		<script src="contrib/jquery/jquery-3.3.1.min.js"></script>
		<!-- EOQ includes -->
		<script src="../eoq2/util/logger.js"></script>
		<script src="../eoq2/query/query.js"></script>
		<script src="../eoq2/command/command.js"></script>
		<script src="../eoq2/eoq2.js"></script>
		<script src="../eoq2/command/result.js"></script>
		<script src="../eoq2/frame/frame.js"></script>
		<script src="../eoq2/event/event.js"></script>
		<script src="../eoq2/domain/domain.js"></script>
		<script src="../eoq2/serialization/serializer.js"></script>
		<script src="../eoq2/serialization/jsonserializer.js"></script>
		<script src="../eoq2/serialization/textserializer.js"></script>
		<script src="../eoq2/domain/remote/websocketdomain.js"></script>
		<script>
			async function BasicWebSocketExample() {
				let webSocketUrl = 'ws://localhost:8000/ws/eoq.do';
				let serializer = new eoq2.serialization.TextSerializer();
	
				//initialize the domain
				let domain = new eoq2.domain.remote.WebSocketDomain(webSocketUrl,logger=new eoq2.util.NoLogging());
	
				await domain.Open();
	
				// Get all elements of class task contained in the workspace
				let allTasks = await domain.Do( CMD.Get(QRY.Cls('Task')) );
				Print("These are all tasks in the workspace: "+serializer.Ser(allTasks));
				
				// Get the name property of all tasks
				let allTaskNames = await domain.Do( CMD.Get(QRY.Cls('Task').Pth('name')) );
				Print("These tasks are named': "+serializer.Ser(allTaskNames));
				
				// Get the name property of all tasks by using intermediate result
				let allTaskNames2 = await domain.Do( CMD.Get(QRY.Arr(allTasks).Pth('name')) );
				Print("These tasks are named (second time)': "+serializer.Ser(allTaskNames2));
				
				// Find the root object of the resource with the name 'MinimalFlightControl.oaam'
				let root = await domain.Do( CMD.Get(QRY.Pth('resources').Sel(QRY.Pth('name').Equ("MinimalFlightControl.oaam")).Idx(0).Pth('contents').Idx(0)) );
				Print("The root object of 'MinimalFlightControl.oaam' is "+serializer.Ser(root));
				
				// Get all elements of class task contained in the models root
				let allTasksInRoot = await domain.Do( CMD.Get(QRY.Qry(root).Cls('Task')) );
				Print("These are all tasks in 'MinimalFlightControl.oaam': "+serializer.Ser(allTasksInRoot));
			}	

			//Define a local print function to print return values assynchrounously to the HTML DOM
			function Print(msg) {
				$("#output").append('<div >'+ msg + '</div>');
			}
		
		</script>
	</head> 
	<body onload="BasicWebSocketExample();">
		<div id="output">
			<!-- all output goes here -->
		</div>
	</body>
</html>